// --------------------------------------------------------------------
// Copyright (c) 2010 by Terasic Technologies Inc.
// --------------------------------------------------------------------
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development
//   Kits made by Terasic.  Other use of this code, including the selling
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use
//   or functionality of this code.
//
// --------------------------------------------------------------------
//
//                     Terasic Technologies Inc
//                     356 Fu-Shin E. Rd Sec. 1. JhuBei City,
//                     HsinChu County, Taiwan
//                     302
//
//                     web: http://www.terasic.com/
//                     email: support@terasic.com
//
// --------------------------------------------------------------------
//
/*

    v1.1.0, 11/28.2013
        -add api: PCIE_Read16, PCIE_Write16, PCIE_Read8, PCIE_Write8

*/

#ifndef __TERASIC_PCIE_AVMM_H__
#define __TERASIC_PCIE_AVMM_H__

/* GNU C/C++ Compiler */
#if defined(__GNUC__)
#include <stdio.h>
#define FAR
#define PASCAL
#define __export
#define BOOL    int
#define TRUE    1
#define FALSE   0
#define DWORD   unsigned int
#define UINT32  unsigned int
#define UINT64  unsigned long long
#define WORD    unsigned short
#define USHORT  unsigned short
#define UCHAR   unsigned char
#define ULONG   unsigned int
#define BYTE    unsigned char
#define _TCHAR  char
#define PCIE_API FAR PASCAL
#else
// MS Windows
#define NOMINMAX // avoid QT compile error
#include <windows.h>
#define PCIE_API __cdecl
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef void *PCIE_HANDLE;
typedef UINT64 PCIE_ADDRESS;
typedef UINT64 PCIE_LOCAL_ADDRESS;

#define DEFAULT_PCIE_VID 0x1172
#define DEFAULT_PCIE_DID 0xE003

typedef enum {
    PCIE_BAR0 = 0,  // do not change it
    PCIE_BAR1,
    PCIE_BAR2,
    PCIE_BAR3,
    PCIE_BAR4,
    PCIE_BAR5
} PCIE_BAR;

typedef struct {
    DWORD dwCounter;   // number of interrupts received
    DWORD dwLost;      // number of interrupts not yet dealt with
    BOOL fStopped;     // was interrupt disabled during wait
} PCIE_INT_RESULT;

//================================================================================
// function prototype used for "static load DLL"
#if 0
PCIE_HANDLE PCIE_API PCIE_Open(WORD wVendorID, WORD wDeviceID, WORD wCardNum);
void PCIE_API PCIE_Close(PCIE_HANDLE hFPGA);
BOOL PCIE_API PCIE_Read32 (PCIE_HANDLE hFPGA, PCIE_BAR PciBar, PCIE_ADDRESS PciAddress, DWORD *pdwData);
BOOL PCIE_API PCIE_Write32 (PCIE_HANDLE hFPGA, PCIE_BAR PciBar, PCIE_ADDRESS PciAddress, DWORD dwData);
BOOL PCIE_API PCIE_DmaRead (PCIE_HANDLE hFPGA, PCIE_LOCAL_ADDRESS LocalAddress, void *pBuffer, DWORD dwBufSize);
BOOL PCIE_API PCIE_DmaWrite (PCIE_HANDLE hFPGA, PCIE_LOCAL_ADDRESS LocalAddress, void *pData, DWORD dwDataSize);
BOOL PCIE_API PCIE_ConfigRead32 (PCIE_HANDLE hFPGA, UINT32 Offset, UINT32 *pData32);
#endif
//================================================================================
// function prototype used for "dynamic load DLL"
typedef PCIE_HANDLE (PCIE_API *LPPCIE_Open)(WORD wVendorID, WORD wDeviceID, WORD wCardNum);
typedef void (PCIE_API *LPPCIE_Close)(PCIE_HANDLE hFPGA);
typedef BOOL (PCIE_API *LPPCIE_Read32)(PCIE_HANDLE hFPGA, PCIE_BAR PciBar, PCIE_ADDRESS PciAddress, DWORD *pdwData);
typedef BOOL (PCIE_API *LPPCIE_Write32)(PCIE_HANDLE hFPGA, PCIE_BAR PciBar, PCIE_ADDRESS PciAddress, DWORD dwData);
typedef BOOL (PCIE_API *LPPCIE_DmaRead) (PCIE_HANDLE hFPGA, PCIE_LOCAL_ADDRESS LocalAddress, void *pBuffer, DWORD dwBufSize);
typedef BOOL (PCIE_API *LPPCIE_DmaWrite) (PCIE_HANDLE hFPGA, PCIE_LOCAL_ADDRESS LocalAddress, void *pData, DWORD dwDataSize);
typedef BOOL (PCIE_API *LPPCIE_ConfigRead32) (PCIE_HANDLE hFPGA, UINT32 Offset, UINT32 *pData32);

#ifdef __cplusplus
}
#endif


#endif /* __TERASIC_PCIE_AVMM_H__ */

